#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

void quit(int returnval);

FILE *inFile;
FILE *outFile;

int main(int argc, char *argv[])
{
    unsigned char ch;
    int size,ii, counter;
    unsigned char marker [] ={0xC7, 0x00, 0x00, 0x00, 0xd6, 0x00, 0x00, 0x00, \
                  0xd4, 0x00, 0x00, 0x00, 0xd1, 0x00, 0x00, 0x00, \
                  0xcf, 0x00, 0x00, 0x00, 0xd7, 0x00, 0x00, 0x00, \
                  0xdd, 0x00, 0x00, 0x00};
	unsigned char gamebuffer[(long)74000];
	char outputfilename [256];


    if (argc < 2)
    {
		printf("This program is to fix a bug with Apple users putting colons in the filename.\n");
        printf("Arguments <filename>\n");
		printf("or....\n");
        printf("Drag and drop a SMAX save file onto this application.\n");
		quit(1);
    }
    else
    {
		printf("Loading save file: %s\n", argv[1]);
    }

	//infile check
	inFile=fopen(argv[1], "rb");

    if (inFile==NULL)
    {
		fprintf(stderr,"Error reading %s.\n",argv[1]);
        quit(1);
    }

	fseek(inFile,(long)0,SEEK_END);
    size = ftell(inFile);
	fseek(inFile,(long)0,SEEK_SET);

	if (size < 74000)
	{
		fprintf(stderr,"File Type: Invalid\n");
		fclose(inFile);
		quit(1);
	}

	//outfile check

	sprintf(outputfilename,"%s.unMACed.sav",argv[1]);
    outFile=fopen(outputfilename, "wb");
    if (outFile==NULL)
    {
        fprintf(stderr,"Error writing to %s.\n",outputfilename);
        quit(1);
    }

	// check that it's SMAX
	fread(gamebuffer,1,(long)74000,inFile);

	counter=0;
	while (marker[counter]==gamebuffer[counter+6141-28] && counter < 28)
	{
		counter++;
	}

	if (counter==28)
	{
		printf("File Type: SMAX\n");
	}
	else
	{
		counter=0;
		while (marker[counter]==gamebuffer[counter+5097-28] && counter < 28)
		{
			counter++;
		}

		if (counter==28)
		{
			printf("This program does not support SMAC.\n");
			quit(2);
		}
		else
		{
			printf("This does not seem to be a SMAC or SMAX file.\n");
			quit(1);
		}
	}

	//insert the null value
	gamebuffer[0x08F8]=0;

	//do the save
    fseek(inFile,(long)0,SEEK_END);
    size = ftell(inFile);
    fseek(inFile,(long)74000,SEEK_SET);

	fwrite(gamebuffer,1,(long)74000,outFile);

	for (ii=74000;ii < size;ii++)
    {
		fputc(fgetc(inFile),outFile);
	}

	fclose(inFile);
	fclose(outFile);


    quit(0);
}


void quit(int returnval)
{
	char ch;
	if (outFile!=NULL)
		fclose(outFile);
	if (inFile!=NULL)
		fclose(inFile);
	printf("Press any key to quit.\n");
	ch = getch();
	if (ch=='?')
		printf("Made by Kody <john@alphadimensions.net> 2006\n");
	exit(returnval);
}

